#!/usr/bin/env python
import os
import sys
import csv
import matplotlib.pyplot as plt
import collections

if len(sys.argv)==2:
	path_input=sys.argv[1].rstrip()
	path_output="./result"
elif len(sys.argv)==3:
	path_input=sys.argv[1].rstrip()
	path_output=sys.argv[2].rstrip()+"./result"
else:
	print "Insert path_input and/or path_output"
	exit (-1)

#creazione cartella output
os.system("rm -r -f "+path_output)
#os.system("mkdir "+path_output)

################################################
#DEF separator

separator=","

################################################

################################################
#protection and metrics

p_Diablo=['vanilla','function_flattening_10%',"branch_functions_10%","opaque_predicates_10%","function_flattening_30%","branch_functions_30%","opaque_predicates_30%","function_flattening_50%","branch_functions_50%","opaque_predicates_50%","Flatten","Opaque","AntiBranchAnalysis","EncodeArithmetic"]
m_Diablo=['nr_ins_static','nr_src_oper_static','nr_dst_oper_static','halstead_program_size_static','nr_edges_static','nr_indirect_edges_CFIM_static','cyclomatic_complexity_static']

p_Frama=['vanilla',"Flatten","Opaque","AntiBranchAnalysis","EncodeArithmetic"]
m_Frama=['Sloc','Decision point','Global variables','If','Loop','Goto','Assignment','Exit point','Function','Function call','Pointer dereferencing','Cyclomatic complexity']

################################################

os.system("mkdir "+path_output)
os.system("mkdir "+path_output+"/frama")
os.system("mkdir "+path_output+"/diablo")

#frama
print "\033[32;1m-----Grafici Frama----\033[0m\n"

book={
'vanilla' : { 	'Sloc' : {},
				'Decision point': {},
				'Global variables': {},
				'If': {},
				'Loop': {},
				'Goto': {},
				'Assignment': {},
				'Exit point': {},
				'Function': {},
				'Function call': {},
				'Pointer dereferencing': {},
				'Cyclomatic complexity': {}
			} ,
"Flatten" : { 	'Sloc' : {},
				'Decision point': {},
				'Global variables': {},
				'If': {},
				'Loop': {},
				'Goto': {},
				'Assignment': {},
				'Exit point': {},
				'Function': {},
				'Function call': {},
				'Pointer dereferencing': {},
				'Cyclomatic complexity': {}
			} ,
"Opaque" : { 	'Sloc' : {},
				'Decision point': {},
				'Global variables': {},
				'If': {},
				'Loop': {},
				'Goto': {},
				'Assignment': {},
				'Exit point': {},
				'Function': {},
				'Function call': {},
				'Pointer dereferencing': {},
				'Cyclomatic complexity': {}
			} ,
"AntiBranchAnalysis": { 	'Sloc' : {},
				'Decision point': {},
				'Global variables': {},
				'If': {},
				'Loop': {},
				'Goto': {},
				'Assignment': {},
				'Exit point': {},
				'Function': {},
				'Function call': {},
				'Pointer dereferencing': {},
				'Cyclomatic complexity': {}
			} , 
"EncodeArithmetic": { 	'Sloc' : {},
				'Decision point': {},
				'Global variables': {},
				'If': {},
				'Loop': {},
				'Goto': {},
				'Assignment': {},
				'Exit point': {},
				'Function': {},
				'Function call': {},
				'Pointer dereferencing': {},
				'Cyclomatic complexity': {}
			} 
}

constrains_min_f={
'Sloc' : 10,
}

constrains_max_f={
'Sloc' : 1000,
}

#retrieve information
os.system("touch "+path_output+"/frama/tmp_frama.csv")
tmp = open(path_output+"/frama/tmp_frama.csv", "a")
lst_def=["#program","protection","tool_protection","target_makefile","path_file_from_main_directory_program","function","flag_obf_tigress(0=made_1=not)","Sloc","Decision point","Global variables","If","Loop","Goto","Assignment","Exit point","Function","Function call","Pointer dereferencing","Cyclomatic complexity"]
tmp.write("#program,protection,tool_protection,target_makefile,path_file_from_main_directory_program,function,flag_obf_tigress(0=made_1=not),Sloc,Decision point,Global variables,If,Loop,Goto,Assignment,Exit point,Function,Function call,Pointer dereferencing,Cyclomatic complexity\n")
for prog in os.popen("ls "+path_input).readlines():
		prog=prog.rstrip()
		f_csv=open(path_input+"/"+prog+"/"+prog+"_frama.csv")
		reader = list(csv.DictReader(f_csv, delimiter=separator))
		lst_funct=[]
		#selec vanilla constrains
		for row in reader:
			blk1=0
			blk2=0
			if row['protection'] == 'vanilla':
				for const in constrains_min_f.keys():
					if int(row[const]) < constrains_min_f[const]:
						blk1 = 1
						break
				if blk1 == 0:
					for const in constrains_max_f.keys():
						if int(row[const]) > constrains_max_f[const]:
							blk2 = 1
							break
				if (blk1==0 and blk2 ==0):
					for i in range(0,len(lst_def)):
						tmp.write(str(row[lst_def[i]])+",")
					tmp.write("\n")
				else:
					lst_funct.append(row['path_file_from_main_directory_program']+"/"+row['function'])
		f_csv.close()
		#write row just selected
		f_csv=open(path_input+"/"+prog+"/"+prog+"_frama.csv")
		reader = list(csv.DictReader(f_csv, delimiter=separator))
		for row in reader:
			if (row['protection'] != 'vanilla') :
				#and (int(row['flag_obf_tigress(0=made_1=not)']) == 0)   condition in the line up
				value= row['path_file_from_main_directory_program']+"/"+row['function']
				if value not in lst_funct:
					for i in range(0,len(lst_def)):
						tmp.write(str(row[lst_def[i]])+",")
					tmp.write("\n")
f_csv.close()
tmp.close()

#grupo informations					
f_csv=open(path_output+"/frama/tmp_frama.csv")
reader = list(csv.DictReader(f_csv, delimiter=separator))
for row in reader:
		for metr in m_Frama:
			tmp= book.get(row['protection']).get(metr)
			if (int(row[metr]) in tmp) == True:
				tmp2= int(tmp.get(int(row[metr]))) +1
				book.get(row['protection']).get(metr).update({int(row[metr]):int(tmp2)})
			else:
				book.get(row['protection']).get(metr).update({int(row[metr]) : int('1')}) 
f_csv.close()

trad_f={
'Sloc':"Linee di codice",
'Decision point':"Numero di punti decisionali",
'Global variables':"Numero di varibili globali",
'If':"Numero di istruzioni if",
'Loop':"Numero di cicli loop",
'Goto':"Numero di istruzioni goto",
'Assignment':"Numero di assegnazioni",
'Exit point':"Numero di exit point",
'Function':"Numero di funzioni contenute nel programma",
'Function call':"Numero di funzioni chiamate",
'Pointer dereferencing':"Numero di pointer dereferencing",
'Cyclomatic complexity':"Complessita' ciclomatica"
}

trad_tmp={
'Sloc':'Sloc',
'Decision point':'Decision_point',
'Global variables':'Global_variables',
'If':"If",
'Loop':"Loop",
'Goto':"Goto",
'Assignment':'Assignment',
'Exit point':'Exit_point',
'Function':'Function',
'Function call':'Function_call',
'Pointer dereferencing':'Pointer_dereferencing',
'Cyclomatic complexity':'Cyclomatic_complexity'
}


trad_t={
"Flatten":"Control flow flattening",
"Opaque":"Predicati opachi",
"AntiBranchAnalysis":"Anti branch analysis",
"EncodeArithmetic":"Encodig"
}


#print plot
for prot in book.keys():
	if prot == "vanilla":
		continue;
	os.system("mkdir "+path_output+"/frama/"+prot)
	for metric in book.get(prot).keys():
		od = collections.OrderedDict(sorted(book.get(prot).get(metric).items()))
		vanilla = collections.OrderedDict(sorted(book.get("vanilla").get(metric).items()))
		plt.plot(vanilla.keys(),vanilla.values(), color="red",linewidth=0.5, linestyle="--", label="vanilla")
		plt.plot(od.keys(),od.values(), color="blue",linewidth=0.5, linestyle="-", label=trad_t[prot])
		plt.legend(loc='best')
		#print od
		#print vanilla
		plt.title(trad_t[prot])
		#print vanilla.items()
		#print od.items()
		#plt.show()
		plt.xlabel(trad_f[metric])
		plt.ylabel("Numero di occorrenze")
		plt.savefig(path_output+"/frama/"+prot+"/"+trad_tmp[metric]+".eps", format='eps', dpi=1200)
		plt.clf()



#Diablo	
print "\033[32;1m-----Grafici Diablo----\033[0m\n"

book_d={
'vanilla' :{ 'nr_ins_static' : {},
				'nr_src_oper_static' : {},
				'nr_dst_oper_static' : {},
				'halstead_program_size_static' : {},	
				'nr_edges_static' : {},
				'nr_indirect_edges_CFIM_static' : {},	
				'cyclomatic_complexity_static' : {}
			},
"Flatten" :{ 'nr_ins_static' : {},
				'nr_src_oper_static' : {},
				'nr_dst_oper_static' : {},
				'halstead_program_size_static' : {},	
				'nr_edges_static' : {},
				'nr_indirect_edges_CFIM_static' : {},	
				'cyclomatic_complexity_static' : {}
			},
"Opaque" :{ 'nr_ins_static' : {},
				'nr_src_oper_static' : {},
				'nr_dst_oper_static' : {},
				'halstead_program_size_static' : {},	
				'nr_edges_static' : {},
				'nr_indirect_edges_CFIM_static' : {},	
				'cyclomatic_complexity_static' : {}
			},
"AntiBranchAnalysis":{ 'nr_ins_static' : {},
				'nr_src_oper_static' : {},
				'nr_dst_oper_static' : {},
				'halstead_program_size_static' : {},	
				'nr_edges_static' : {},
				'nr_indirect_edges_CFIM_static' : {},	
				'cyclomatic_complexity_static' : {}
			},
"EncodeArithmetic":{ 'nr_ins_static' : {},
				'nr_src_oper_static' : {},
				'nr_dst_oper_static' : {},
				'halstead_program_size_static' : {},	
				'nr_edges_static' : {},
				'nr_indirect_edges_CFIM_static' : {},	
				'cyclomatic_complexity_static' : {}
			},
'function_flattening_10%' :{ 'nr_ins_static' : {},
				'nr_src_oper_static' : {},
				'nr_dst_oper_static' : {},
				'halstead_program_size_static' : {},	
				'nr_edges_static' : {},
				'nr_indirect_edges_CFIM_static' : {},	
				'cyclomatic_complexity_static' : {}
			},
"branch_functions_10%" :{ 'nr_ins_static' : {},
				'nr_src_oper_static' : {},
				'nr_dst_oper_static' : {},
				'halstead_program_size_static' : {},	
				'nr_edges_static' : {},
				'nr_indirect_edges_CFIM_static' : {},	
				'cyclomatic_complexity_static' : {}
			},
"opaque_predicates_10%" :{ 'nr_ins_static' : {},
				'nr_src_oper_static' : {},
				'nr_dst_oper_static' : {},
				'halstead_program_size_static' : {},	
				'nr_edges_static' : {},
				'nr_indirect_edges_CFIM_static' : {},	
				'cyclomatic_complexity_static' : {}
			},
"function_flattening_30%" :{ 'nr_ins_static' : {},
				'nr_src_oper_static' : {},
				'nr_dst_oper_static' : {},
				'halstead_program_size_static' : {},	
				'nr_edges_static' : {},
				'nr_indirect_edges_CFIM_static' : {},	
				'cyclomatic_complexity_static' : {}
			},
"branch_functions_30%" :{ 'nr_ins_static' : {},
				'nr_src_oper_static' : {},
				'nr_dst_oper_static' : {},
				'halstead_program_size_static' : {},	
				'nr_edges_static' : {},
				'nr_indirect_edges_CFIM_static' : {},	
				'cyclomatic_complexity_static' : {}
			},
"opaque_predicates_30%" :{ 'nr_ins_static' : {},
				'nr_src_oper_static' : {},
				'nr_dst_oper_static' : {},
				'halstead_program_size_static' : {},	
				'nr_edges_static' : {},
				'nr_indirect_edges_CFIM_static' : {},	
				'cyclomatic_complexity_static' : {}
			},
"function_flattening_50%" :{ 'nr_ins_static' : {},
				'nr_src_oper_static' : {},
				'nr_dst_oper_static' : {},
				'halstead_program_size_static' : {},	
				'nr_edges_static' : {},
				'nr_indirect_edges_CFIM_static' : {},	
				'cyclomatic_complexity_static' : {}
			},
"branch_functions_50%" :{ 'nr_ins_static' : {},
				'nr_src_oper_static' : {},
				'nr_dst_oper_static' : {},
				'halstead_program_size_static' : {},	
				'nr_edges_static' : {},
				'nr_indirect_edges_CFIM_static' : {},	
				'cyclomatic_complexity_static' : {}
			},
"opaque_predicates_50%" :{ 'nr_ins_static' : {},
				'nr_src_oper_static' : {},
				'nr_dst_oper_static' : {},
				'halstead_program_size_static' : {},	
				'nr_edges_static' : {},
				'nr_indirect_edges_CFIM_static' : {},	
				'cyclomatic_complexity_static' : {}
			}
}

constrains_min_d={
'nr_ins_static' : 30,
'nr_edges_static' : 6,
}

constrains_max_d={
'nr_ins_static' : 2000,
}

#retrieve information
os.system("touch "+path_output+"/diablo/tmp_diablo.csv")
tmp = open(path_output+"/diablo/tmp_diablo.csv", "a")
lst_def=["#program","protection","tool_protection","target_makefile","path_file_from_main_directory_program","function","flag_obf_tigress(0=made_1=not)","nr_ins_static","nr_src_oper_static","nr_dst_oper_static","halstead_program_size_static","nr_edges_static","nr_indirect_edges_CFIM_static","cyclomatic_complexity_static"]
tmp.write("#program,protection,tool_protection,target_makefile,path_file_from_main_directory_program,function,flag_obf_tigress(0=made_1=not),nr_ins_static,nr_src_oper_static,nr_dst_oper_static,halstead_program_size_static,nr_edges_static,nr_indirect_edges_CFIM_static,cyclomatic_complexity_static\n")
for prog in os.popen("ls "+path_input).readlines():
		prog=prog.rstrip()
		f_csv=open(path_input+"/"+prog+"/"+prog+"_diablo.csv")
		reader = list(csv.DictReader(f_csv, delimiter=separator))
		lst_funct_d=[]
		#selec vanilla constrains
		for row in reader:
			blk1=0
			blk2=0
			if row['protection'] == 'vanilla':
				for const in constrains_min_d.keys():
					if int(row[const]) < constrains_min_d[const]:
						blk1 = 1
						break
				if blk1 == 0:
					for const in constrains_max_d.keys():
						if int(row[const]) > constrains_max_d[const]:
							blk2 = 1
							break
				if (blk1==0 and blk2 ==0):
					for i in range(0,len(lst_def)):
						tmp.write(str(row[lst_def[i]])+",")
					tmp.write("\n")
				else:
					lst_funct_d.append(row['path_file_from_main_directory_program']+"/"+row['function'])
		f_csv.close()
		#write row just selected
		f_csv=open(path_input+"/"+prog+"/"+prog+"_diablo.csv")
		reader = list(csv.DictReader(f_csv, delimiter=separator))
		for row in reader:
			if (row['protection'] != 'vanilla') :
				#and (int(row['flag_obf_tigress(0=made_1=not)']) == 0)   condition in the line up
				value= row['path_file_from_main_directory_program']+"/"+row['function']
				if value not in lst_funct_d:
					for i in range(0,len(lst_def)):
						tmp.write(str(row[lst_def[i]])+",")
					tmp.write("\n")
f_csv.close()
tmp.close()

#grupo informations					
f_csv=open(path_output+"/diablo/tmp_diablo.csv")
reader = list(csv.DictReader(f_csv, delimiter=separator))
for row in reader:
		for metr in m_Diablo:
			tmp= book_d.get(row['protection']).get(metr)
			if (int(row[metr]) in tmp) == True:
				tmp2= int(tmp.get(int(row[metr]))) +1
				book_d.get(row['protection']).get(metr).update({int(row[metr]):int(tmp2)})
			else:
				book_d.get(row['protection']).get(metr).update({int(row[metr]) : int('1')}) 
f_csv.close()

trad_di_m={
'nr_ins_static' : "Numero di istruzioni assembly",
'nr_src_oper_static': "Numero di operandi sorgente",
'nr_dst_oper_static': "Numero di operandi destinazione",
'halstead_program_size_static' : "Lunghezza di Halstead",
'nr_edges_static': "Numero ramificazioni del control flow graph",
'nr_indirect_edges_CFIM_static' : "Numero di ramificazioni indirette",
'cyclomatic_complexity_static': "Complessita' ciclomatica"
}

trad_di={
"function_flattening_10%":"Control flow flattening 10%",
"function_flattening_30%":"Control flow flattening 30%",
"function_flattening_50%":"Control flow flattening 50%",
"opaque_predicates_10%":"Predicati opachi 10%",
"opaque_predicates_30%":"Predicati opachi 30%",
"opaque_predicates_50%":"Predicati opachi 50%",
"branch_functions_10%":"Anti branch analysis 10%",
"branch_functions_30%":"Anti branch analysis 30%",
"branch_functions_50%":"Anti branch analysis 50%",
}

p_Diablo_tmp=['vanilla','function_flattening_10%',"branch_functions_10%","opaque_predicates_10%","function_flattening_30%","branch_functions_30%","opaque_predicates_30%","function_flattening_50%","branch_functions_50%","opaque_predicates_50%"]
#print plot
for prot in p_Diablo_tmp:
	if prot == "vanilla":
		continue;
	os.system("mkdir "+path_output+"/diablo/"+prot)
	for metric in book_d.get(prot).keys():
		od = collections.OrderedDict(sorted(book_d.get(prot).get(metric).items()))
		vanilla = collections.OrderedDict(sorted(book_d.get("vanilla").get(metric).items()))
		plt.plot(vanilla.keys(),vanilla.values(), color="red",linewidth=0.5, linestyle="--", label="vanilla")
		plt.plot(od.keys(),od.values(), color="blue",linewidth=0.5, linestyle="-", label=trad_di[prot])
		plt.legend(loc='best')
		#print od
		#print vanilla
		plt.title(trad_di[prot])
		#print vanilla.items()
		#print od.items()
		#plt.show()
		plt.xlabel(trad_di_m[metric])
		plt.ylabel("Numero di occorrenze")
		plt.savefig(path_output+"/diablo/"+prot+"/"+metric+".eps", format='eps', dpi=1200)
		plt.clf()

