#!/usr/bin/env python
import os
import sys
import string
import re
import json

report_diablo_clean=sys.argv[1]+"/clean"
report_diablo_obf=sys.argv[1]+"/obf"
pre_analized=sys.argv[2]


def Search_if_obf(_dir,_file):
	if(os.popen("grep "+_file.replace(".txt","")+" "+_dir+"/filenotobf/file.txt").read()!=""):
		return 1
	else:
		return 0

def Create_cvs_diablo(prog,obf,tool,_dir):
	for command in os.popen("ls "+_dir):
		cmd=command.replace(prog+"_","").rstrip() #obtain cmd
		
		#read json
		annotation=open(_dir+"/"+command.rstrip()+"/annotations.json","r")
		data_json=json.load(annotation)
		
		#read file report
		report=os.popen("find "+_dir+"/"+command.rstrip()+" -name *.stat_regions_complexity_info").readline().rstrip() #sure of find only one file
		file_report=open(report,"r").readlines()
		
		#open file csv
		csv=open(pre_analized+"/"+prog+"/"+prog+"_diablo.csv","a")
		
		#parse file_report and write in csv
		for cnt in range(1,len(file_report)): #0=first line, jump it
			values=file_report[cnt].split(",")
			index=int(values[0])
			
			#extract name_file and function
			name_file=re.sub("^(.)*/"+prog+"_"+cmd,"/"+prog,data_json[index]["file name"]).rstrip()
			funct=data_json[index]["function name"]
			
			#megainint and *_i$nit not used
			if(funct=="megaInit" or funct.find("_i$nit")!=-1):
				continue
			
			
			#write flag_obf_tigress
			if(tool!="tigress"):
				flag="0"
			else:
				_file=re.sub("^.*/","",name_file)
				flag=Search_if_obf(_dir+"/"+command.rstrip(),_file)
			
			#write csv	
			csv.write(prog+","+obf+","+tool+","+cmd+","+name_file+","+funct+","+str(flag))
			for i in range(1,len(values)): #0=index
				csv.write(","+values[i].replace(" ","").rstrip())
		
			csv.write("\n")
		#close file
		annotation.close()
		csv.close()
		
		
		
		annotation.close()


#######################################################################
#######################################################################
#########     		create cvs for diablo report               ########
#######################################################################
#######################################################################

#report diablo clean
for prog in os.popen("ls "+pre_analized).readlines():
	prog=prog.rstrip() #obtain prog
	Create_cvs_diablo(prog,"vanilla","null",report_diablo_clean+"/"+prog)

#report diablo obf 
for tool in os.popen("ls "+report_diablo_obf).readlines():
	tool=tool.rstrip() # obtain tool
	for obf in os.popen("ls "+report_diablo_obf+"/"+tool).readlines():
		obf=obf.rstrip() #obtain obf
		for prog in os.popen("ls "+pre_analized).readlines():
			prog=prog.rstrip() #obtain prog
			Create_cvs_diablo(prog,obf,tool,report_diablo_obf+"/"+tool+"/"+obf+"/"+prog)

