#!/usr/bin/env python
import os
import sys
import string
import re
import csv
import math

def Varianza(media,list_values):
	list_tmp=[]
	for value in list_values:
		list_tmp.append((value-media)*(value-media))
	if len(list_tmp)==1:
		return float(0)
	else:
		return float(sum(list_tmp))/float(len(list_tmp)-1)

def Media_Potency(protection,metric):
	list_values=[]
	_sum=0
	media=0
	varianza=0
	dev=0
	std_error=0
	for row in reader_tmp:
		if row['#protection']==protection and int(row['flag_obf_tigress(0=made_1=not)'])==0:
			if row[metric]=='nan':
				continue
			list_values.append(float(row[metric]))
	_sum=sum(list_values)
	if(len(list_values)==0):
		media='nan'
		varianza='nan'
		dev='nan'
		std_error='nan'
	else:
		media=float(_sum) / float(len(list_values))
		varianza=Varianza(media,list_values)
		dev=math.sqrt(varianza)
		std_error=float(dev) / float(len(list_values))
	report.write(protection+','+metric+','+str(media)+","+str(len(list_values))+","+str(varianza)+","+str((len(list_values)-1))+","+str(dev)+","+str(std_error)+"\n")	
	

def Potency(row_vanilla,_type,_list):
	if _type=='frama':
		for protection in p_Frama:
			_list_tmp=_list
			for row in _list_tmp:
				if row['protection']==protection and row_vanilla['target_makefile']==row['target_makefile'] and row_vanilla['function']==row['function']:
					report.write(row['protection']+','+row['target_makefile']+','+row['path_file_from_main_directory_program']+','+row['function']+','+row['flag_obf_tigress(0=made_1=not)'])
					for metric in m_Frama:
						if int(row_vanilla[metric])==0:
							potency='nan'
						else:
							#potency=float(float(row[metric])/float(float(row_vanilla[metric])-1))
							potency=float(float(float(row[metric])/float(row_vanilla[metric]))-1)
						report.write(','+str(potency))
					report.write("\n")
	elif _type=='diablo':
		for protection in p_Diablo:
			_list_tmp=_list
			for row in _list_tmp:
				if row['protection']==protection and row_vanilla['target_makefile']==row['target_makefile'] and row_vanilla['function']==row['function']:
					report.write(row['protection']+','+row['target_makefile']+','+row['path_file_from_main_directory_program']+','+row['function']+','+row['flag_obf_tigress(0=made_1=not)'])
					for metric in m_Diablo:
						potency=0
						if int(row_vanilla[metric])==0:
							potency='nan'
						else:
							#potency=float(float(row[metric])/float(float(row_vanilla[metric])-1))
							potency=float(float(float(row[metric])/float(row_vanilla[metric]))-1)
						report.write(','+str(potency))
						'''
						if row_vanilla['function']=='free_mem' and row['protection']=='opaque_predicates_50%':
							print 'Protection -> '+ protection
							print 'function : '+row_vanilla['function']+'=='+row['function']
							print metric+" : "+row[metric]+" "+row_vanilla[metric]
							print 'potency='+str(potency)
						'''
					report.write("\n")
		
################################################
'''
Def header row

Diablo:
#program,protection,tool_protection,target_makefile,path_file_from_main_directory_program,function,flag_obf_tigress(0=made_1=not),nr_ins_static,nr_src_oper_static,nr_dst_oper_static,halstead_program_size_static,nr_edges_static,nr_indirect_edges_CFIM_static,cyclomatic_complexity_static + Flatten,Opaque,AntiBranchAnalysis

Frama:
#program,protection,tool_protection,target_makefile,path_file_from_main_directory_program,function,flag_obf_tigress(0=made_1=not),Sloc,Decision point,Global variables,If,Loop,Goto,Assignment,Exit point,Function,Function call,Pointer dereferencing,Cyclomatic complexity

'''
################################################

################################################
#protection and metrics

vanilla='vanilla'

p_Diablo=['function_flattening_10%',"branch_functions_10%","opaque_predicates_10%","function_flattening_30%","branch_functions_30%","opaque_predicates_30%","function_flattening_50%","branch_functions_50%","opaque_predicates_50%","Flatten","Opaque","AntiBranchAnalysis","EncodeArithmetic"]
m_Diablo=['nr_ins_static','nr_src_oper_static','nr_dst_oper_static','halstead_program_size_static','nr_edges_static','nr_indirect_edges_CFIM_static','cyclomatic_complexity_static']
Wmcp_Diablo={
'nr_ins_static' : '1',
'nr_src_oper_static': '1',
'nr_dst_oper_static' : '1',
'halstead_program_size_static' : '1',
'nr_edges_static' : '1',
'nr_indirect_edges_CFIM_static' : '1',
'cyclomatic_complexity_static' : '1'
}

p_Frama=["Flatten","Opaque","AntiBranchAnalysis","EncodeArithmetic"]
m_Frama=['Sloc','Decision point','Global variables','If','Loop','Goto','Assignment','Exit point','Function','Function call','Pointer dereferencing','Cyclomatic complexity']

################################################

################################################
#DEF separator

separator=","

################################################


#input
if len(sys.argv)==2:
	path_input=sys.argv[1].rstrip()
	path_output="./potency"
elif len(sys.argv)==3:
	path_input=sys.argv[1].rstrip()
	path_output=sys.argv[2].rstrip()+"./potency"
else:
	print "Insert path_input and/or path_output"
	exit (-1)
	

os.system("rm -r -f "+path_output)
os.system("mkdir "+path_output)


#Potency

print "\n\033[32;1m-----Potency for every function and protection for each program-----\033[0m\n"

for prog in os.popen("ls "+path_input).readlines():
	prog=prog.rstrip()
	os.system("mkdir -p "+path_output+"/"+prog)
	
	#potency frama
	file_report=path_output+"/"+prog+"/"+prog+"_potency_function_protection_frama.csv"

	report=open(file_report,"a")
	report.write("#protection,target_makefile,path_file_from_main_directory_program,function,flag_obf_tigress(0=made_1=not),Sloc,Decision point,Global variables,If,Loop,Goto,Assignment,Exit point,Function,Function call,Pointer dereferencing,Cyclomatic complexity\n")
	
	
	f_csv=open(path_input+"/"+prog+"/"+prog+"_frama.csv")
	reader = list(csv.DictReader(f_csv, delimiter=separator))
	reader_tmp=reader
	f_csv.close()
	
	for row in reader:
		if row['protection']==vanilla:
			Potency(row,'frama',reader_tmp)
	report.close()
	
	#potency diablo
	file_report=path_output+"/"+prog+"/"+prog+"_potency_function_protection_diablo.csv"

	report=open(file_report,"a")
	report.write("#protection,target_makefile,path_file_from_main_directory_program,function,flag_obf_tigress(0=made_1=not),nr_ins_static,nr_src_oper_static,nr_dst_oper_static,halstead_program_size_static,nr_edges_static,nr_indirect_edges_CFIM_static,cyclomatic_complexity_static\n")
	
	f_csv=open(path_input+"/"+prog+"/"+prog+"_diablo.csv")
	reader = list(csv.DictReader(f_csv, delimiter=separator))
	reader_tmp=reader
	f_csv.close()
	
	for row in reader:
		if row['protection']==vanilla:
			Potency(row,'diablo',reader_tmp)
	report.close()
	

#Media,Std_dev, variance, Std_err on potency on all target makeFile
	
print "\033[32;1m-----Media,Std_dev Potency for every protection-----\033[0m\n"

for prog in os.popen("ls "+path_output).readlines():
	#media potency frama
	prog=prog.rstrip()
	file_report=path_output+"/"+prog+"/"+prog+"_media_potency_protection_frama.csv"
	report=open(file_report,"a")
	report.write("#protection,metric,media,num_samples_m,variance,num_samples_v,std_dev,std_err\n")
	
	f_csv=open(path_output+"/"+prog+"/"+prog+"_potency_function_protection_frama.csv")
	reader = list(csv.DictReader(f_csv, delimiter=separator))
	
	for protection in p_Frama:
		for metric in m_Frama:
			reader_tmp=reader
			Media_Potency(protection,metric)

	#media potency diablo
	file_report=path_output+"/"+prog+"/"+prog+"_media_potency_protection_diablo.csv"
	report=open(file_report,"a")
	report.write("#protection,metric,media,num_samples_m,variance,num_samples_v,std_dev,std_err\n")
	
	f_csv=open(path_output+"/"+prog+"/"+prog+"_potency_function_protection_diablo.csv")
	reader = list(csv.DictReader(f_csv, delimiter=separator))
	
	for protection in p_Diablo:
		for metric in m_Diablo:
			reader_tmp=reader
			Media_Potency(protection,metric)
			

#Combined Potency (diablo)

print "\033[32;1m-----Combined Potency for every protection (only Diablo)----\033[0m\n"

for prog in os.popen("ls "+path_output).readlines():
	prog=prog.rstrip()
	file_report=path_output+"/"+prog+"/"+prog+"_Combined_potency_function_protection_diablo.csv"
	report=open(file_report,"a")
	report.write("#protection,target_makefile,path_file_from_main_directory_program,function,Combined_Potency\n")

	f_csv=open(path_output+"/"+prog+"/"+prog+"_potency_function_protection_diablo.csv")
	reader = list(csv.DictReader(f_csv, delimiter=separator))
	
	for row in reader:
		c_potency=0
		for metric,weight in Wmcp_Diablo.items():
			if int(row['flag_obf_tigress(0=made_1=not)'])==1:
				continue
			if row[metric]=='nan':
				c_potency=c_potency+0
			else:
				c_potency=c_potency+float(float(row[metric])*float(weight))
		report.write(row['#protection']+','+row['target_makefile']+','+row['path_file_from_main_directory_program']+','+row['function']+','+str(c_potency)+'\n')


#Media,Std_dev, variance, Std_err on combined potency on all target makeFile	

print "\033[32;1m-----Media,Std_dev Combined Potency for every protection (only Diablo)-----\033[0m\n"

for prog in os.popen("ls "+path_output).readlines():
	prog=prog.rstrip()
	file_report=path_output+"/"+prog+"/"+prog+"_Media_Combined_potency_protection_diablo.csv"
	report=open(file_report,"a")
	report.write("#protection,metric,media,num_samples_m,variance,num_samples_v,std_dev,std_err\n")
	
	f_csv=open(path_output+"/"+prog+"/"+prog+"_Combined_potency_function_protection_diablo.csv")
	reader = list(csv.DictReader(f_csv, delimiter=separator))
	
	for protection in p_Diablo:
		reader_tmp=reader
		list_values=[]
		_sum=0
		media=0
		varianza=0
		dev=0
		std_error=0
		for row in reader_tmp:
			if row['#protection']==protection:
				list_values.append(float(row['Combined_Potency']))
		_sum=sum(list_values)
		if(len(list_values)==0):
			media='nan'
			varianza='nan'
			dev='nan'
			std_error='nan'
		else:
			media=float(_sum) / float(len(list_values))
			varianza=Varianza(media,list_values)
			dev=math.sqrt(varianza)
			std_error=float(dev) / float(len(list_values))
		report.write(protection+','+'Combined_Potency'+','+str(media)+","+str(len(list_values))+","+str(varianza)+","+str((len(list_values)-1))+","+str(dev)+","+str(std_error)+"\n")	

		
			
	
	
	

	
	
	
	

	
	
	
	
	
