#!/usr/bin/env python
import os
import sys
import string
import re
import csv
import math
import matplotlib.pyplot as plt
from operator import itemgetter


		
################################################
'''
Def header row

Diablo:
#program,protection,tool_protection,target_makefile,path_file_from_main_directory_program,function,flag_obf_tigress(0=made_1=not),nr_ins_static,nr_src_oper_static,nr_dst_oper_static,halstead_program_size_static,nr_edges_static,nr_indirect_edges_CFIM_static,cyclomatic_complexity_static + Flatten,Opaque,AntiBranchAnalysis

Frama:
#program,protection,tool_protection,target_makefile,path_file_from_main_directory_program,function,flag_obf_tigress(0=made_1=not),Sloc,Decision point,Global variables,If,Loop,Goto,Assignment,Exit point,Function,Function call,Pointer dereferencing,Cyclomatic complexity

'''
################################################

################################################
#protection and metrics

vanilla='vanilla'

p_Diablo=['function_flattening_10%',"branch_functions_10%","opaque_predicates_10%","function_flattening_30%","branch_functions_30%","opaque_predicates_30%","function_flattening_50%","branch_functions_50%","opaque_predicates_50%"]
m_Diablo=['nr_ins_static','nr_src_oper_static','nr_dst_oper_static','halstead_program_size_static','nr_edges_static','nr_indirect_edges_CFIM_static','cyclomatic_complexity_static']
Wmcp_Diablo={
'nr_ins_static' : '1',
'nr_src_oper_static': '1',
'nr_dst_oper_static' : '1',
'halstead_program_size_static' : '1',
'nr_edges_static' : '1',
'nr_indirect_edges_CFIM_static' : '1',
'cyclomatic_complexity_static' : '1'
}

dic_Frama={}
dic_Diablo={}
dic_tmp={}

p_Frama=["Flatten","Opaque","AntiBranchAnalysis","EncodeArithmetic"]
m_Frama=['Sloc','Decision point','Global variables','If','Loop','Goto','Assignment','Exit point','Function','Function call','Pointer dereferencing','Cyclomatic complexity']

################################################

################################################
#DEF separator

separator=","

################################################


#input
if len(sys.argv)==2:
	path_input=sys.argv[1].rstrip()
	path_output="./potency_funzionanti_tmp"
elif len(sys.argv)==3:
	path_input=sys.argv[1].rstrip()
	path_output=sys.argv[2].rstrip()+"./potency_funzionanti_tmp"
else:
	print "Insert path_input and/or path_output"
	exit (-1)
	



#os.system("mkdir "+path_output)


#Potency_funzionanti Frama

print "\n\033[32;1m-----Potency Frama-----\033[0m\n"

trad_f={
'Sloc':"Linee di codice",
'Decision point':"Numero di punti decisionali",
'Global variables':"Numero di varibili globali",
'If':"Numero di istruzioni if",
'Loop':"Numero di cicli loop",
'Goto':"Numero di istruzioni goto",
'Assignment':"Numero di assegnazioni",
'Exit point':"Numero di exit point",
'Function':"Numero di funzioni contenute nel programma",
'Function call':"Numero di funzioni chiamate",
'Pointer dereferencing':"Numero di pointer dereferencing",
'Cyclomatic complexity':"Complessita' ciclomatica"
}

trad_t={
"Flatten":"Control flow flattening",
"Opaque":"Predicati opachi",
"AntiBranchAnalysis":"Anti branch analysis",
"EncodeArithmetic":"Encodig"
}

os.system("rm -r -f "+path_output+"/Frama/")
os.system("rm -r -f "+path_output+"/tmp_Frama.csv")

file_report=path_output+"/tmp_Frama.csv"
os.system("mkdir -p "+path_output+"/Frama/")
report=open(file_report,"a")
report.write("#protection,name,Sloc,Decision point,Global variables,If,Loop,Goto,Assignment,Exit point,Function,Function call,Pointer dereferencing,Cyclomatic complexity\n")
	
for prot in p_Frama:
	os.system("mkdir -p "+path_output+"/Frama/"+prot)
	for prog in os.popen("ls "+path_input).readlines():
		prog=prog.rstrip()
		#os.system("mkdir -p "+path_output+"/"+prog)
		
		f_csv=open(path_input+"/"+prog+"/"+prog+"_frama.csv")
		reader = list(csv.DictReader(f_csv, delimiter=separator))
		
		for row in reader:
			
			if row['protection']==prot:
				f_csv_tmp=open(path_input+"/"+prog+"/"+prog+"_frama.csv")
				reader_tmp=list(csv.DictReader(f_csv_tmp, delimiter=separator))
				
				for row_tmp in reader_tmp:
					
					if (row_tmp['protection']==vanilla) and (row['path_file_from_main_directory_program']==row_tmp['path_file_from_main_directory_program']) and (row['function']==row_tmp['function']):
						report.write(prot+","+row['target_makefile']+"__"+row['path_file_from_main_directory_program']+"__"+row['function'])
						for i in range(0,len(m_Frama)):
							if int(row_tmp[m_Frama[i]]) ==0:
								if int(row[m_Frama[i]])==0:
									report.write(",0")
								else:
									report.write(",nan")
							else:
								res=float(float(row[m_Frama[i]])/float(row_tmp[m_Frama[i]])) -1
								report.write(","+str(res))
						report.write('\n')
						#break
				f_csv_tmp.close()
		f_csv.close()
report.close()


for prot in p_Frama:
	dic_Frama={}
	report_file=open(file_report)
	reader=list(csv.DictReader(report_file, delimiter=separator))
	for row in reader:
		if row['#protection']==prot:
			if dic_Frama.has_key(row['name'])==0: 
				dic_Frama.update({row['name']: float(row['Cyclomatic complexity'])})
	report_file.close()
	tmp=sorted(dic_Frama.items(), key=itemgetter(1))
	v_cc=[]
	k_cc=[]
	for i in range(0,len(tmp)):
		j_cc=tmp[i]
		k_cc.append(j_cc[0])
		v_cc.append(j_cc[1])
	dic_Frama={}	
	
	for metr in m_Frama:
		dic_Frama={}	
		if metr == ' ':
			continue
		else:
			report_file=open(file_report)
			reader=list(csv.DictReader(report_file, delimiter=separator))
			for row in reader:
				if row['#protection']==prot:
					if dic_Frama.has_key(row['name'])==0: 
						dic_Frama.update({row['name']: float(row[metr])})
			v_metr=[]		
			for i in range(0,len(k_cc)):
				v_metr.append(float(dic_Frama[k_cc[i]]))
			plt.plot(k_cc, v_metr, color="blue",linewidth=0.5, linestyle="-", label=trad_f[metr])
			plt.plot(k_cc,v_cc,color="red",linewidth=0.5, linestyle="-", label=trad_f["Cyclomatic complexity"])	
			plt.title(trad_t[prot])
			plt.legend(loc='best')
			plt.ylabel('Potency')
			plt.tick_params(axis='x', which='both', bottom=False, top=False, labelbottom=False) 
			plt.xlabel('ID funzione')
			plt.savefig(path_output+"/Frama/"+prot+"/"+metr+".eps", format='eps', dpi=1200)
			plt.clf()	
		report_file.close()		
		
'''

#Potency_funzionanti Diablo
print "\n\033[32;1m-----Potency Diablo-----\033[0m\n"

os.system("rm -r -f "+path_output+"/Diablo/")
os.system("rm -r -f "+path_output+"/tmp_Diablo.csv")

file_report=path_output+"/tmp_Diablo.csv"
os.system("mkdir -p "+path_output+"/Diablo/")
report=open(file_report,"a")
report.write("#protection,name,nr_ins_static,nr_src_oper_static,nr_dst_oper_static,halstead_program_size_static,nr_edges_static,nr_indirect_edges_CFIM_static,cyclomatic_complexity_static\n")
	
for prot in p_Diablo:
	os.system("mkdir -p "+path_output+"/Diablo/"+prot)
	for prog in os.popen("ls "+path_input).readlines():
		prog=prog.rstrip()
		#os.system("mkdir -p "+path_output+"/"+prog)
		
		f_csv=open(path_input+"/"+prog+"/"+prog+"_diablo.csv")
		reader = list(csv.DictReader(f_csv, delimiter=separator))
		
		for row in reader:
			
			if row['protection']==prot:
				f_csv_tmp=open(path_input+"/"+prog+"/"+prog+"_diablo.csv")
				reader_tmp=list(csv.DictReader(f_csv_tmp, delimiter=separator))
				
				for row_tmp in reader_tmp:
					
					if (row_tmp['protection']==vanilla) and (row['path_file_from_main_directory_program']==row_tmp['path_file_from_main_directory_program']) and (row['function']==row_tmp['function']):
						report.write(prot+","+row['target_makefile']+"__"+row['path_file_from_main_directory_program']+"__"+row['function'])
						for i in range(0,len(m_Diablo)):
							if int(row_tmp[m_Diablo[i]]) ==0:
								if int(row[m_Diablo[i]])==0:
									report.write(",0")
								else:
									report.write(",nan")
							else:
								res=float(float(row[m_Diablo[i]])/float(row_tmp[m_Diablo[i]])) -1
								report.write(","+str(res))
						report.write('\n')
						break
				f_csv_tmp.close()
		f_csv.close()
report.close()


for prot in p_Diablo:
	dic_Diablo={}
	report_file=open(file_report)
	reader=list(csv.DictReader(report_file, delimiter=separator))
	for row in reader:
		if row['#protection']==prot:
			if dic_Diablo.has_key(row['name'])==0: 
				dic_Diablo.update({row['name']: float(row['halstead_program_size_static'])})
	report_file.close()
	tmp=sorted(dic_Diablo.items(), key=itemgetter(1))
	v_cc=[]
	k_cc=[]
	for i in range(0,len(tmp)):
		j_cc=tmp[i]
		k_cc.append(j_cc[0])
		v_cc.append(j_cc[1])
	dic_Diablo={}	
	
	for metr in m_Diablo:
		dic_Diablo={}	
		if metr == 'Cyclomatic complexity':
			continue
		else:
			report_file=open(file_report)
			reader=list(csv.DictReader(report_file, delimiter=separator))
			for row in reader:
				if row['#protection']==prot:
					if dic_Diablo.has_key(row['name'])==0: 
						dic_Diablo.update({row['name']: float(row[metr])})
			v_metr=[]		
			for i in range(0,len(k_cc)):
				v_metr.append(float(dic_Diablo[k_cc[i]]))
			plt.plot(k_cc, v_metr, color="blue",linewidth=0.5, linestyle="-", label=metr)
			plt.plot(k_cc,v_cc,color="red",linewidth=0.5, linestyle="-", label="cyclomatic_complexity_static")	
			plt.title(prot+" - "+metr)
			plt.legend(loc='best')
			plt.ylabel('Valore metrica')
			plt.xlabel('ID funzione')
			plt.savefig(path_output+"/Diablo/"+prot+"/"+metr+".eps", format='eps', dpi=1200)
			#plt.show()
			plt.clf()	
		report_file.close()		
'''
